Uses
  Crt,
  Turbo3,
  DOS;

{$R-}                   {Range checking off}
{$B+}                   {Boolean complete evaluation on}
{$S+}                   {Stack checking on}
{$I+}                   {I/O checking on}
{$M 32150,1250,1250}          {Declared here suffices for all Units as well!}
{$V-}

type
  astr = String[160];  { generic string type for parameters      }
                       { note the change from Waynes str => Astr }

const
  buffer_max = 5120;


CONST strlen=160;
      maxusers=500;
      dsaves : Integer = 0;

TYPE restrictions=(rlogon,rchat,rvalidate,rbackspace,ramsg,rpostan,
                   rpost,remail,rvoting,rmsg);
     acrq='@'..'G';
     newtyp=(rp,lt,rm);
     str40=string[40];
     deflts=(spcsr,onekey,wordwrap,pause,mmnu,ansi,color,music);
     pnr=record name:string[40]; number:string[14]; hs:byte; end;
     anontyp=(no,yes,forced,dearabby);
     ansttype=(postn,emailn,pana,sanm,cosysop,lcosysop);
     opts=(alert,smw,nomail);
     dlnscan=set of 0..39;
     emary=array[1..20] of integer;
     clrs=array[false..true,1..8] of byte;
     clrs2=array[false..true,0..9] of byte;
     slr=record
           ttime:byte;
           mallowed:integer;
           emails,posts:byte;
           anst:set of ansttype;
         end;
     messages=record
                ltr:char;
                number:integer;
                ext:byte;
              end;
     smalrec=record
               name:string[25];
               number:integer;
             end;
     userrec=record
               name:string[21];
               realname:string[18];
               deleted:boolean;
               pw:string[8];
               ph:string[12];
               waiting:byte;
               laston:string[10];
               loggedon:integer;
               msgpost:integer;
               emailsent:integer;
               feedback:integer;
               linelen:byte;
               pagelen:byte;
               defaults:set of deflts;
               ontoday:byte;
               illegal:byte;
               ttimeon:real;
               dlnscn:dlnscan;
               sl:byte;
               ac:set of restrictions;
               ar:set of acrq;
               qscan:array[1..19] of messages;
               qscn:array[1..19] of boolean;
               macro:array[1..2] of string[79];
               comptype:byte;
               option:set of opts;
               vote:array[1..9] of byte;
               sbn:byte;
               dsl:byte;
               uploads,downloads:integer;
               uk,dk:integer;
               age:byte;
               sex:char;
               note:string[39];
               forusr:integer;
               cols:clrs;                (* Res[2] will be last file area *)
               res:array[1..72] of byte; (* Res[1] will be last msg base *)
               citystate:string[26];
               street:string[21];
               zipcode:string[10];
               occupation:string[40];
               wherebbs:string[40];
               lockedout:boolean;
               lockedfile:string[8];
               computer:string[14];
               cols2:clrs2;
             end;
      boardrec=record
                 name:string[30];
                 filename:string[12];
                 sl:byte;
                 maxmsgs:byte;
                 pw:string[10];
                 anonymous:anontyp;
                 ar:acrq;
                 key:char;
                 postsl:byte;
               end;
      msgstat=(validated,unvalidated,deleted);
      messagerec=record
                   title:string[30];
                   messagestat:msgstat;
                   message:messages;
                   owner:integer;
                   date:integer;
                   mage:byte;
                 end;
      systatrec=record
                  boardpw:string[8];
                  sysoppw:string[8];
                  hmsg:messages;
                  users:integer;
                  lastdate:string[8];
                  callernum:integer;
                  activetoday:integer;
                  callstoday:integer;
                  msgposttoday:integer;
                  emailtoday:integer;
                  fbacktoday:integer;
                  uptoday:integer;
                  closedsystem:boolean;
                  comport:byte;
                  maxbaud:integer;
                  msgpath:string[79];
                  gfiledate:string[8];
                  lowtime,hitime:integer;
                  res:array[1..200] of byte;
                  engage:string[55];
                  endchat:string[55];
                  alias:boolean;
                  echoc:astr;
                  sysopin:astr;
                  sysopout:astr;
                  note:array[1..2] of string[79];
                  lprompt:astr;
                  lansi:boolean;
                  init:astr;
                  wait:astr;
                  app:boolean;
                  fone:boolean;
                  sysopmacro:array[1..9] of string[72];
                  forcevoting:boolean;
                  multitask:boolean;
                  gfilepath:string[79];
                  pause:string[20];
                  hangup:string[40];
                  answer:string[40];
                  result300:integer;
                  result1200:integer;
                  result2400:integer;
                  nocarrier:integer;
                  filesl:byte;
                  tries:byte;
                  newsl:byte;
                  newdsl:byte;
                  newar:set of acrq;
                  newac:set of restrictions;
                  newdk:integer;
                  newuk:integer;
                  bwindow:boolean;
                  bsdelay:byte;
                  mcimsg:boolean;
                  b300lowtime,b300hitime:integer;
                  dllowtime,dlhitime:integer;
                  b300dllowtime,b300dlhitime:integer;
                  lock300:boolean;
                  result4800:integer;
                  result9600:integer;
                  SysopFirst:String[12];
                  SysopLast:String[16];
                  BBSName:String[40];
                  BBSPhone:String[12];
                  ANSIq:String[40];
                  WantQuote:Boolean;
                  Menupath:string[79];
                  autosl:byte;
                  autodsl:byte;
                  autoar:set of acrq;
                  autoac:set of restrictions;
               end;
      blk=array[1..255] of byte;
      mailrec=record
                title:string[30];
                from,destin:integer;
                msg:messages;
                date:integer;
                mage:byte;
              end;
      gft=record
            num:integer;
            title:string[40];
            filen:string[12];
          end;
      smr=record
            msg:astr;
            destin:integer;
          end;
      vdatar=record
               question:string[79];
               numa:integer;
               answ:array[0..9] of record
                      ans:string[25];
                      numres:integer;
                    end;
             end;
      ulrec=record
              name:string[25];
              filename:string[12];
              password:string[10];
              dsl:byte;
              maxfiles:integer;
              key:char;
              ulpath:string[39];
              dlpath:string[40];
              agereq:byte;
              ar:acrq;
            end;
      ulfrec=record
               filename:string[12];
               description:string[60];
               filepoints:byte;
               res:array[1..16] of byte;
               nacc:integer;
               ft:byte;
               blocks:integer;
               owner:integer;
               date:string[8];
               daten:integer;
             end;
      strptr=^strrec;
      strrec=record
               i:astr;
               next,last:strptr;
             end;
      zlogt=record
              date:string[8];
              active,calls,post,email,fback,up:integer;
            end;
{    expro=record
             descr:string[30];
             rcmd:string[50];
             scmd:string[50];
             xferok:integer;
           end;}

CONST dcols:clrs=((7,7,15,15,15,112,7,143),(3,1,11,9,14,31,4,140));
      dcols2:clrs2=((15,7,7,15,15,15,112,7,143,7),(15,3,1,11,9,14,31,4,140,10));

var sf:file of smalrec;
    uf:file of userrec;
    bf:file of boardrec;
{   xp:file of expro;}
    mailfile:file of mailrec;
    ulf:file of ulrec;
    uboards:array[0..39] of ulrec;
{   protocals:array [0..4] of expro;}
    maxulb:integer;
    sysopf:text{[1024]};
    slf:file of slr;
    seclev:array[0..255] of slr;
    systatf:file of systatrec;
    systat:systatrec;
    sr:smalrec;
    thisline,chatr,buf,spd,irt,lastname,ll,i:astr;
    thisuser,user:userrec;
    boards:array[1..19] of boardrec;
    fw,extramsgs,mread,board,numboards,t,usernum,numprotocals:integer;
    pap,lil,realsl,realdsl,ftoday,ptoday,etoday:integer;
    c,ID:char;
    rep,hungup,useron,next,chatcall,doneday,echo,hangup,incom,outcom:boolean;
    extratime,chattime,timeon:real;
    mailread,smread,macok,lan,enddayf,ch,quit,beepend:boolean;
    smf:file of smr;
    vqu:array[1..9] of boolean;
    ldate:integer;
    cmd:char;
    bread:byte;
    bchanged:boolean;
    cf:text; cfo,okt:boolean;
    elevel:byte;
    curco:byte;
    sll:astr;
    andwith:byte;
    checkit:boolean;
    geek:astr;
    lmain:boolean;
    lmsg:boolean;
    windowon,entry,wantfilename,nofile,nofeed:boolean;
    nopfile:boolean;
    reading_a_msg,write_msg:boolean;
    wantout:boolean;
    wcolor:boolean;
    Filv:Text;
    N:Astr;
    noc    : integer;
    found  : boolean;
    directive,menuprompt:astr;
    FILEBOARD:integer;
    first_time:boolean;
    ulff:file of ulfrec;
    crc:integer;
    doit:boolean;
    sortbd,doneft:boolean;
    ldat:astr;
    ix:array[1..9] of string[79];
    ymodem,ucrc,bnp:boolean;
    c1,c2,c3:integer;
    chksum:byte;
    lrn:integer;
    lfn:astr;
    all:boolean;
    ft:byte;
    ymbtt:real;
    ymodemfiles:integer;
    ymbindx:integer;
    ymbary:array[1..20] of record
      fn:string[80];
      tt:real;
    end;
    dta:string[44];
    filenamef,s1,s2,s3:astr;
    donedos,dld,d1,d2,done,abort:boolean;
    cd,cmdlist,start_dir:astr;
    returna,quitafterdone:boolean;
    answerbaud:integer;
    topheap:^byte;
    i1:astr;
    f,f1:file of byte;
    x:byte;
    lastvar:byte;

function tch(i:astr):astr;
begin
  if length(i)>2 then i:=copy(i,length(i)-1,2) else
    if length(i)=1 then i:='0'+i;
  tch:=i;
end;

function date:astr;
var reg:registers;
    m,d,y:string[4];
begin
  reg.ax:=$2a00; msdos(Dos.Registers(reg)); str(reg.cx,y); str(reg.dx mod 256,d);
  str(reg.dx shr 8,m);
  date:=tch(m)+'/'+tch(d)+'/'+tch(y);
end;

function checkpw:boolean;
begin
  checkpw:=true;
end;

procedure prompt(i:astr);
begin
  write(i);
end;

procedure print(i:astr);
begin
  writeln(i);
end;

procedure cl(i:integer);
begin
  textcolor(i);
end;

function okansi:boolean;
begin
  okansi:=true;
end;

procedure savesystat;  (* save systat *)
begin
  reset(systatf); write(systatf,systat); close(systatf);
end;

function cstr(i:integer):astr;
var c:astr;
begin
  str(i,c); cstr:=c;
end;

procedure prt(i:astr);
begin
  cl(9);
  write(i);
end;

procedure nl;
begin
  writeln;
end;

procedure onek(var c:char; ch:astr);    (* 1 Key example: onkey(c,'1234'); *)
var i1,i:astr; tf:boolean;
begin
  tf:=false;
  repeat
    c:=readkey;
    c:=upcase(c);
    tf:=true;
  until (pos(c,ch)>0);
  writeln(c);
end;


function mln(i:astr; l:integer):astr;
begin
  while length(i)<l do i:=i+' ';
  mln:=i;
end;

function mn(i,l:integer):astr;
begin
  mn:=mln(cstr(i),l);
end;

function value(I:astr):integer;
var n,n1:integer;
begin
  val(i,n,n1);
  if n1<>0 then begin
    i:=copy(i,1,n1-1);
    val(i,n,n1)
  end;
  value:=n;
  if i='' then value:=0;
end;

procedure cls;
begin
  clrscr;
end;

procedure checkhangup;
begin
end;

procedure local_input1(var i:astr; ml:integer; tf:boolean);
var cp:integer;
    cc:char;
    r:real;
begin
  cp:=1;
  repeat
    cc:=readkey;
    if not tf then cc:=upcase(cc);
    if (cc>=' ') and (cc<chr(127)) then
      if cp<=ml then begin
      i[cp]:=cc;
      cp:=cp+1;
      write(cc);
    end else else case ord(cc) of
      8:if cp>1 then begin
               cc:=chr(8);
               write(cc);write(' '); write(cc);
               cp:=cp-1;
             end;
      21,24:while cp<>1 do begin
               cp:=cp-1;
               write(#8);write(' ');write(#8);
             end;
      end;
  until (cc=#13) or (cc=#14);
  i[0]:=chr(cp-1);
  writeln;
end;

procedure getkey(c:Char);
begin
  c:=readkey;
end;

procedure local_input(var i:astr; ml:integer);  (* Input uppercase only *)
begin
  local_input1(i,ml,false);
end;

procedure local_inputl(var i:astr; ml:integer);   (* Local_Input lower & upper case *)
begin
  local_input1(i,ml,true);
end;

procedure gfileedit;
var b,b1:gft; f:file of gft; i:astr; t,c:integer; ok,exit:boolean;
    gftit:array[1..150] of record tit:string[80]; arn:integer; gfile:boolean;end;
    nums,lgftn,numgft:integer;
    gfs:array[0..100] of record tit:string[80]; arn:integer; end;
    c1,c2,c3,c4:integer; s1,s2,s3,s4:astr; ch:char;

  procedure gettit(n:integer);
  var r:integer; b:gft;
  begin
    numgft:=0;
    r:=n+1;
    if r<=t then begin
      seek(f,r); read(f,b);
      while (r<=t) and (b.filen[1]<>#1) do begin
        begin
          numgft:=numgft+1;
          gftit[numgft].tit:=b.title;
          gftit[numgft].arn:=r;
          gftit[numgft].gfile:=true;
        end;
        r:=r+1;
        if (r<=t) then begin seek(f,r); read(f,b);end;
      end;
    end;
  end;

  procedure getsec;
  var r:integer; b:gft;
  begin
    nums:=0;
    gfs[0].tit:='[ Main Section ]';
    gfs[0].arn:=0;
    for r:=1 to t do begin
      seek(f,r); read(f,b);
      if b.filen[1]=#1 then begin
        nums:=nums+1;
        gfs[nums].tit:='[ '+b.title+' ]';
        gfs[nums].arn:=r;
      end;
    end;
    gfs[nums+1].arn:=t+1;
  end;

  procedure listsec;
  var r:integer; i:astr; abort,next:boolean;
  begin
    r:=0; abort:=false; nl; nl;
    while (r<=nums) and (not abort) do begin
      cl(13); write(cstr(r)); cl(11);
      writeln(': '+gfs[r].tit);
      r:=r+1;
    end;
  end;

  procedure lgft;
  var abort,next:boolean; c:integer; b:gft; x:integer;
  begin
    nl; nl;
    if numgft=0 then print('No G-files.') else begin
      abort:=false; next:=false; c:=1; clrscr;
      cl(15);
      Writeln('NN  File Name       SL    Description');
      cl(9);
      repeat x:=wherex; if x<>79 then write(''); until (x=79); writeln;
      while (c<=numgft) and (not abort) do begin
        seek(f,gftit[c].arn); read(f,b);
        if length(cstr(c))<2 then write(' ');
        cl(13); write(cstr(c)); cl(11);
        write(': '); { if length(i)=6 then i:=' '+i;}
        write(b.filen);
        x:=wherex;
        while x<21 do begin write(' '); x:=x+1; end;
        write(cstr(b.num));
        x:=wherex;
        while x<27 do begin write(' '); x:=x+1; end;
        write(b.title);
        writeln;
        c:=c+1;
      end;
      writeln;
    end;
  end;

begin
  clrscr;
              nl;
              cl(11);prompt('Q');cl(3);prompt(':uit from gfile edit   ');cl(11);prompt('?');cl(3);print(':this list');
              cl(11);prompt('I');cl(3);prompt(':nsert G-file          ');cl(11);prompt('D');cl(3);print(':delete G-file');
              cl(11);prompt('S');cl(3);print(':ection modification');
  nl;assign(f,systat.gfilepath+'gfiles.dat'); {$I-} reset(f); {$I+}
  if ioresult<>0 then begin
    rewrite(f); b.num:=0; write(f,b);
  end;
  seek(f,0); read(f,b); t:=b.num; exit:=false;
    repeat
      nl; nl; prt('Gfile Edit: Q,I,D,S,? : ');
      onek(ch,'QIDS?'); getsec;
      case ch of
        'Q':exit:=true;
        '?':begin
              nl;
              cl(11);prompt('Q');cl(3);prompt(':uit from gfile edit   ');cl(11);prompt('?');cl(3);print(':this list');
              cl(11);prompt('I');cl(3);prompt(':nsert G-file          ');cl(11);prompt('D');cl(3);print(':delete G-file');
              cl(11);prompt('S');cl(3);print(':ection modification');
            end;
        'S':begin
              prompt('I:nsert, D:elete, Q:uit ? '); onek(ch,'QID');
              case ch of
                'I':begin
                      listsec;
                      prompt('Before which section (1-'+cstr(nums+1)+') : '); local_input(s1,2);
                      c1:=value(s1);
                      if (c1>0) and (c1<=(nums+1)) then begin
                        if c1<=nums then
                          c1:=gfs[c1].arn
                        else
                          c1:=t+1;
                        prompt('Section title? '); local_inputl(b.title,40);
                        prompt('SL requirement? '); local_input(s1,3);
                        b.num:=value(s1); b.filen:=#1#0#0#0#0#0;
                        for c3:=t downto c1 do begin
                          seek(f,c3); read(f,b1); seek(f,c3+1); write(f,b1);
                        end;
                        seek(f,c1); write(f,b); t:=t+1;
                        b.num:=t; seek(f,0); write(f,b);
                      end else print('Illegal section number.');
                    end;
                'D':begin
                      listsec;
                      prompt('Delete which section (1-'+cstr(nums)+') : '); local_input(s1,2);
                      c1:=value(s1);
                      if ((c1>0) and (c1<=nums)) then begin
                        c2:=gfs[c1].arn;
                        if c1=nums then c3:=t+1 else c3:=gfs[c1+1].arn;
                        c1:=(c3-c2);
                        for c4:=c3 to t do begin
                          seek(f,c4); read(f,b); seek(f,c4-c1); write(f,b);
                        end;
                        seek(f,0); t:=t-c1; b.num:=t; write(f,b);
                      end;
                    end;
              end;
            end;
        'D':begin
              listsec;
              prompt('Which section (0-'+cstr(nums)+') : '); local_input(s1,2);
              c1:=value(s1);
              if (s1='0') or ((c1>0) and (c1<=nums)) then begin
                gettit(gfs[c1].arn);
                lgft;
                prompt('Delete which (1-'+cstr(numgft)+') :');
                local_input(s1,3);
                c1:=value(s1);
                if (c1>0) and (c1<=(numgft)) then begin
                  c1:=gftit[c1].arn;
                  for c2:=c1+1 to t do begin
                    seek(f,c2); read(f,b); seek(f,c2-1); write(f,b);
                  end;
                  seek(f,0); read(f,b); b.num:=b.num-1;
                  seek(f,0); write(f,b); t:=t-1;
                end;
              end;
            end;
        'I':begin
              listsec;
              prompt('Which section (0-'+cstr(nums)+') : '); local_input(s1,2);
              c1:=value(s1);
              if (s1='0') or ((c1>0) and (c1<=nums)) then begin
                gettit(gfs[c1].arn);
                lgft; c4:=c1;
                prt('Insert before which (1-'+cstr(numgft+1)+') :');
                local_input(s1,3);
                c1:=value(s1);
                if (c1>0) and (c1<=(numgft+1)) then begin
                  if c1<=numgft then
                    c2:=gftit[c1].arn
                  else
                    c2:=gfs[c4+1].arn;
                  prompt('Enter filename of new G-file : ');{mpl(12);}
                  local_input(b.filen,12); if (pos('.TXT',b.filen)=0) and
                  (pos('.MSG',b.filen)=0) and (pos('.ANS',b.filen)=0) then b.filen:='';
                  assign(
                  f1,systat.gfilepath+b.filen); {$I-} reset(f1); {$I+}
                  ok:=false; if ioresult=0 then begin close(f1); ok:=true; end;
                  if b.filen='' then ok:=false;
                  if ok then begin
                    nl; prompt('Enter title : '); { mpl(40); } local_inputl(b.title,40);
                    prompt('Enter SL : '); {mpl(3);}
                    local_input(i,3); b.num:=value(i);
                    for c3:=t downto c2 do begin
                      seek(f,c3); read(f,b1); seek(f,c3+1); write(f,b1);
                    end;
                    seek(f,c2); write(f,b); t:=t+1;
                    seek(f,0); read(f,b); b.num:=b.num+1; seek(f,0); write(f,b);
                    systat.gfiledate:=date; savesystat;
                  end else print('Illegal filename.');
                end;
              end;
            end;
      end;
    until exit or hangup;
  close(f);
  nl;nl;
end;

procedure chsldata;
var a,csl:byte; ch:char; done:boolean;

  function inf:astr;
    function ml(i:integer):astr;
    var s:astr;
    begin
      s:=cstr(i); while length(s)<6 do s:=s+' ';
      ml:=s;
    end;
    function yy(a:ansttype):astr;
    begin
      if a in seclev[csl].anst then
        yy:='Yes   '
      else
        yy:='No    ';
    end;
  begin
    with seclev[csl] do
      inf:=ml(csl)+ml(ttime)+ml(mallowed)+'  '+ml(emails)+ml(posts)+
         yy(pana)+yy(sanm)+yy(postn)+yy(emailn)+yy(lcosysop)+yy(cosysop);
  end;

  procedure changesldata;
  var c:char; i:astr;
    function yn1(x:boolean):boolean;
    var c:char;
    begin
      repeat
        c:=readkey;
        c:=upcase(c);
      until (c='Y') or (c='N') or (c=#13);
      if c='Y' then
        x:=true
      else
        if c='N' then
          x:=false;
      if x then
        write('Yes   ')
      else
        write('No    ');
      yn1:=x;
    end;

    procedure chg(a:ansttype);
    begin
      if yn1(a in seclev[csl].anst) then
        seclev[csl].anst:=seclev[csl].anst+[a]
      else
        seclev[csl].anst:=seclev[csl].anst-[a];
    end;

    procedure chbyte(var b:byte);
    var i:astr; x,y:integer;
    begin
      x:=wherex; y:=wherey;
      write(cstr(b)); gotoxy(x,y);
     Local_Input(i,3);
      if i<>'' then b:=value(i);
      gotoxy(x,y);
      i:=cstr(b);
      while length(i)<6 do
        i:=i+' ';
      write(i);
    end;

    procedure chint(var b:integer);
    var i:astr; x,y:integer;
    begin
      x:=wherex; y:=wherey;
      write(cstr(b)); gotoxy(x,y);
     Local_Input(i,5);
      if i<>'' then b:=value(i);
      gotoxy(x,y);
      i:=cstr(b);
      while length(i)<8 do
        i:=i+' ';
      write(i);
    end;
  begin
    gotoxy(1,4);
    write(inf);
    gotoxy(7,4);
    with seclev[csl] do begin
      chbyte(ttime);
      chint(mallowed);
      chbyte(emails);
      chbyte(posts);
      chg(pana); chg(sanm); chg(postn); chg(emailn); chg(lcosysop); chg(cosysop);
    end;
  end;

begin
    clrscr;
cl(15);
    writeln('                                Anony write Anony read  Lt''d  Full ');
    writeln('SL    Time  Msgs    Email Post  Msgs  Email Msgs  Email C-SO  C-SO ');
    cl(13);
    writeln('-------------------------------------------------------------------');
    csl:=10;
    done:=false;
    gotoxy(1,6);
    cl(10);
    writeln('[,] = up/down one SL');
    writeln('{,} = up/down 10 SL');
    writeln('C   = change SL data');
    writeln('S   = save changed data');
    writeln('L   = load old data');
    writeln('Q   = quit to BBS'); cl(3);
    repeat
      gotoxy(1,4);
      writeln(inf);
      read(kbd,ch);
      ch:=upcase(ch);
      case ch of
        'Q':done:=true;
        ']':csl:=csl+1;
        '[':csl:=csl-1;
        '}':csl:=csl+10;
        '{':csl:=csl-10;
        'C':changesldata;
        'S':begin
              assign(slf,systat.gfilepath+'seclev.dat'); reset(slf);
              for a:=0 to 255 do write(slf,seclev[a]);
              close(slf);
            end;
        'L':begin
              assign(slf,systat.gfilepath+'seclev.dat'); reset(slf);
              for a:=0 to 255 do read(slf,seclev[a]);
              close(slf);
            end;
      end;
    until done or hangup;
    clrscr;
end;

Procedure Tcenter(Z:Astr);
Var Y,P:Integer;
Begin
  P:=40-(length(z) div 2);
  y:=wherey;
  gotoxy(p,y);
  writeln(z);
End;

Procedure Tcenter2(Z:Astr);
Var Y,P:Integer;
Begin
  P:=40-(length(z) div 2);
  y:=wherey;
  gotoxy(p,y);
  write(z);
End;

var a:integer;
Begin
  hangup:=false;
  assign(systatf,'status.dat');
  reset(systatf); read(systatf,systat);close(systatf);
  repeat
  window(1,1,80,25);
  clrscr;
  gotoxy(1,1);
  textbackground(1);
  cl(15);clreol;Tcenter('Telegard External Sysop Utilities v1.5c');
  textbackground(0); gotoxy(1,10);
  cl(13);
  Tcenter('Select External SysOp Utility: ');
  cl(11);
  Tcenter('1. Security Level Config');
  Tcenter('2. General File Edit    '); writeln;
  cl(14);
  Tcenter('Q. Quit back to BBS     ');
  cl(10); writeln;
  Tcenter2('Selection: '); cl(9);
  onek(c,'12Q34');
  case c of
    '1':begin
          gotoxy(1,1); textbackground(1);
          cl(15);clreol;Tcenter('Security Level Edit');
          textbackground(0); gotoxy(1,10);
          window(1,2,80,25);
          assign(slf,systat.gfilepath+'seclev.dat'); reset(slf); for a:=0 to 255 do read(slf,seclev[a]);
          close(slf);
          chsldata;
        end;
    '2':begin
          gotoxY(1,1); textbackground(1); cl(15);clreol;Tcenter('General File Edit');
          textbackground(0); gotoxy(1,10);
          window(1,2,80,25);
          gfileedit;
        end;
   end;
   until (c='Q');
end.
